
local function load_groupies()
	local num = gkini.ReadInt("groupies", "num", 0)
	local groupies = {}
	for i=1,num do
		local entry = gkini.ReadString("groupies", tostring(i), "")
		if entry == "" then
			break
		end
		groupies[entry] = true
	end
	return groupies
end

local function save_groupies(groupies)
	local i = 1
	for entry in pairs(groupies) do
		gkini.WriteString("groupies", tostring(i), entry)
		i = i + 1
	end
	gkini.WriteString("groupies", "num", i)
end

local groupies = load_groupies()
local regroup_after_mission = nil


local function groupies_cb(event, data)
	if data and type(data.msg) == "string" then
		for entry in pairs(groupies) do
			if data.msg == "You have been invited to "..entry.."'s group." then
				if GetNumActiveMissions() > 0 then
					regroup_after_mission = entry
					AbortMission()
				elseif GetNumGroupMembers() > 0 then
					Group.Leave()
					Group.Join(entry)
				else
					Group.Join(entry)
				end
				return
			end
		end
		
	end
end

RegisterEvent(groupies_cb, "CHAT_MSG_SERVER")


local function mission_removed_cb(event)
	if regroup_after_mission then
		local tmp = regroup_after_mission
		regroup_after_mission = nil
		if GetNumGroupMembers() > 0 then
			Group.Leave()
		end
		Group.Join(tmp)
	end
end
RegisterEvent(mission_removed_cb, "MISSION_REMOVED")


local function groupies_cb(_, args)
	if args then
		if args[1] == "add" and args[2] and args[2] ~= "" then
			groupies[args[2]] = true
			save_groupies(groupies)
		elseif args[1] == "del" then
			groupies[args[2]] = nil
			save_groupies(groupies)
		elseif args[1] == "list" then
			print("groupies:")
			for entry in pairs(groupies) do
				print(entry)
			end
		end
	end
end
RegisterUserCommand("groupies", groupies_cb)
